=encoding utf8

=head1 NAME

Mail::Message::Construct::Read - read a Mail::Message from a file handle

=head1 SYNOPSIS

  my $msg1 = Mail::Message->read(\*STDIN);
  my $msg2 = Mail::Message->read(\@lines);

=head1 DESCRIPTION

When complex methods are called on a C<Mail::Message> object, this package
is autoloaded to support the reading of messages directly from any file
handle.

=head1 METHODS

=head2 Constructing a message

=over 4

=item $class-E<gt>B<read>($fh|$text|\$text|\@lines, %options)

Read a message from a C<$fh>, C<$text> string, reference to a text string, or an
ARRAY of C<@lines>.  Most C<%options> are passed to the L<new()|Mail::Message/"Constructors"> of the message
which is created, but a few extra are defined.

Please have a look at L<build()|Mail::Message::Construct::Build/"Constructing a message"> and L<buildFromBody()|Mail::Message::Construct::Build/"Constructing a message"> before thinking about
this C<read> method.  Use this C<read> only when you have a file-handle
like STDIN to parse from, or some external source of message lines.
When you already have a separate set of head and body lines, then C<read>
is certainly B<not> your best choice.

Some people use this method in a procmail script: the message arrives
at stdin, so we only have a filehandle.  In this case, you are stuck
with this method.  The message is preceded by a line which can be used
as message separator in mbox folders.  See the example how to handle
that one.

This method will remove C<Status> and C<X-Status> fields when they appear
in the source, to avoid the risk that these fields accidentally interfere
with your internal administration, which may have security implications.

 -Option             --Default
  body_type            undef
  parser_class         undef
  seekable             false
  strip_status_fields  true
  trusted              true

=over 2

=item body_type => $type

Force a body C<$type> (any specific extension of the L<Mail::Message::Body|Mail::Message::Body> class)
to be used to store the message content.  When the body is a multipart or
nested, this will be overruled.

=item parser_class => $type

Enforce a certain parser C<$type> to be used, which must be an extension of
the L<Mail::Box::Parser|Mail::Box::Parser> class otherwise taken.

=item seekable => BOOLEAN

Indicate that a seekable file-handle has been passed. In this case, we
can use the L<Mail::Box::Parser::Perl|Mail::Box::Parser::Perl> parser which reads messages
directly from the input stream.

=item strip_status_fields => BOOLEAN

Remove the C<Status> and C<X-Status> fields from the message after
reading, to lower the risk that received messages from external
sources interfere with your internal administration.  If you want
fields not to be stripped (you would like to disable the stripping)
you probably process folders yourself, which is a Bad Thing!

=item trusted => BOOLEAN

=back

» example: 

  my $msg1 = Mail::Message->read(\*STDIN);
  my $msg2 = Mail::Message->read(\@lines);
  $folder->addMessages($msg1, $msg2);

  my $msg3 = Mail::Message->read(<<MSG);
  Subject: hello world
  To: you@example.com
                       # warning: empty line required !!!
  Hi, greetings!
  MSG

  # promail example
  my $fromline = <STDIN>;
  my $msg      = Mail::Message->read(\*STDIN);
  my $coerced  = $mboxfolder->addMessage($msg);
  $coerced->fromLine($fromline);

=back

=head1 DIAGNOSTICS

=over 4

=item Error: cannot read message from a $source}.

Cast by C<read()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.03,
built on January 26, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

